unit SchBldrUtils;
{$mode objfpc}{$H+}
interface // this section makes stuff visible to other units
uses  Classes, SysUtils, StrUtils;

function st(i: integer): string;  // integer -> string
function nt(st: string): integer; // string -> integer
function CpyWrd(n: integer; st: string): string;
function ExtWrd(n: integer; var st: string): string;
procedure InsWrd(txt: string; wrd: integer; var st: string);
procedure RplWrd(txt: string; wrd: integer; var st: string);
function CpyInt(n: integer; st: string): integer;
procedure InsInt(num,wrd: integer; var st: string);
procedure RplInt(num,wrd: integer; var st: string);

//function LnkSrt(TSL: TStringList; a,b: integer): integer;
function IsWildNumMatch(S,W: string): boolean;
function FixedBounds(var n: integer; min,max: integer): boolean;
procedure CalcHV(var H,V: integer; Symbols: integer);
procedure ConsolodatePairs(var PairList: TStringList);
function FoundInRange
  (ID: string; var n: integer; min,max: integer; DataStr: string): boolean;

const grid=16; tgrid=8; // LTspice constants
  WhtSp = [#0..' ']; DeviceIDs = ['A'..'J','L','M','O','Q'..'W','Y','Z'];

implementation

function st(i: integer): string; // integer -> string
  var s: string; begin Str(i,s); st:=s+' '; end;

function nt(st: string): integer; // string -> integer
  begin Val(st,nt); end;

// returns a copy of the Nth word from the string
function CpyWrd(n: integer; st: string): string;
  begin CpyWrd:= ExtractWord(n,st,WhtSp); end;

// removes and returns the Nth word from the string
function ExtWrd(n: integer; var st: string): string; var p1,p2: integer;
  begin
   ExtWrd:= ExtractWordPos(n,st,WhtSp,p1);
   ExtractWordPos(n+1,st,WhtSp,p2);
   if(p2<=p1)then p2:=length(st)+1;
   Delete(st,p1,p2-p1);
  end;

// inserts at the Nth word in the string an additional substring
procedure InsWrd(txt: string; wrd: integer; var st: string);
  begin
   Insert(txt+' ',st,WordPosition(wrd,st,WhtSp)); // insert txt at position wrd
  end;

// replaces the Nth word in the string with a new substring
procedure RplWrd(txt: string; wrd: integer; var st: string);
  var len,pos: integer;
  begin
   len:= length(ExtractWordPos(wrd,st,WhtSp,pos)); // old position & length
   st:= StuffString(st,pos,len,txt); // replace the old with the new
  end; // write_str:= StuffString(read_str,start,length,insert_str)

// returns a copy of the Nth word from the string as an integer
function CpyInt(n: integer; st: string): integer;
  begin Val(ExtractWord(n,st,WhtSp),CpyInt); end;

// inserts at the Nth word in the string an integer (converted to string)
procedure InsInt(num,wrd: integer; var st: string);
  var txt: string;
  begin
   Str(num,txt); // convert the new number to txt
   Insert(txt+' ',st,WordPosition(wrd,st,WhtSp)); // insert txt at position wrd
  end;

// replaces the Nth word in the string with an integer (converted to string)
procedure RplInt(num,wrd: integer; var st: string);
  var len,pos: integer; txt: string;
  begin
   len:= length(ExtractWordPos(wrd,st,WhtSp,pos)); // old position & length
   Str(num,txt); // convert the new number to txt
   if pos>0 then st:= StuffString(st,pos,len,txt); // replace the old with the new
  end; // write_str:= StuffString(read_str,start,length,insert_str)

// Link Custom Sort
function LnkSrt(TSL: TStringList; a,b: integer): integer;
  var La,Lb: integer; const Lnk=4; WS = [#0..' '];
  begin Val(ExtractWord(Lnk,TSL[a],WS),La); Val(ExtractWord(Lnk,TSL[b],WS),Lb);
    if La<Lb then LnkSrt:=-1 else if La=Lb then LnkSrt:= 0 else LnkSrt:=1;
  end;

function IsWildNumMatch(S,W: string): boolean;
  var n,L,R,m: integer;
  begin S:= UpCase(S); W:= UpCase(W);
    n:= Pos('#',W); if(n=0)
      then IsWildNumMatch:= (S=W)
      else begin L:= n-1; R:= Length(W)-n;
        if(LeftStr(W,L)=LeftStr(S,L))and(RightStr(W,R)=RightStr(S,R))
          then begin m:= Length(S)-Length(W)+1;
            W:= Copy(S,n,m); IsWildNumMatch:= true;
            for n:= 1 to Length(W) do begin S:= Copy(W,n,1);
              IsWildNumMatch:= (IsWildNumMatch)and(S[1]in['0'..'9']); end;
          end else IsWildNumMatch:= false;
  end;end;

function FixedBounds(var n: integer; min,max: integer): boolean;
  begin
    FixedBounds:= true;
    if n<min then begin n:= min; Exit; end;
    if n>max then begin n:= max; Exit; end;
    FixedBounds:= false;
  end;

procedure CalcHV(var H,V: integer; Symbols: integer); const BlkRatio=1.3;
  begin
    H:= 0; repeat inc(H) until H*H>=Symbols; // integer "squareroot"
    H:= round(BlkRatio*H*10)div(10); // horizontal size of symbol field
    V:= 0; repeat inc(V) until H*V>=Symbols; // vertical size of symbol field
  end;

procedure ConsolodatePairs(var PairList: TStringList);
  var i: integer; W1: string;
  begin i:= 0;
    with PairList do repeat W1:= CpyWrd(1,Strings[i]);
      while(i<Count-1)and(W1=CpyWrd(1,Strings[i+1]))do begin
        Strings[i]:=Strings[i]+' '+CpyWrd(2,Strings[i+1]); Delete(i+1); end;
    inc(i); until(i>=Count);
  end;

function FoundInRange
  (ID: string; var n: integer; min,max: integer; DataStr: string): boolean;
  const Delims=[#0..' ','=']; var i,c: integer; data: string;
  begin
    FoundInRange:= false; // assume the user errored
    if FixedBounds(n,min,max) then Exit; // bounds error
    i:= 0; c:= WordCount(DataStr,Delims);
    if (length(ID)<=0)or(c<=0) then Exit; // input is invalid
    repeat inc(i) until (ExtractWord(i,DataStr,Delims)=ID)or(i>=c);
    if i>=c then Exit; // ID or value was not in input data string
    data:= Trim(ExtractWord(i+1,DataStr,Delims)); // find next word
    if length(data)<=0 then Exit; // ID's value is a bogus string
    Val(data,i,c); // try to convert value to number (c is error code)
    if not(c=0) then Exit; // ID's value is a bogus number
    n:= i; // only set n if a valid integer value is found
    if FixedBounds(n,min,max) then Exit; // uh-oh, it was out of range
    FoundInRange:= true; // I guess the user wasn't stupid after all
  end;


end. // anything beyond this point is ignored (notes and archive area)
(*****************************************************************************)

function LenXY(x,y,n: integer; var TSL: TStringList): integer;
var i,id: integer; IDx: string;
begin // TSL is the list of ID lines, TSL[n] is the target ID line
  i:= 0; LenXY:= 0;
  for id:= 1 to ExtWrd(5,TSL[n]) do begin IDx:= ExtWrd(5+id,TSL[n]);
    while(ExtWrd(1,TSL[i])<>IDx)do inc(i);
    inc(LenXY,abs(x-nt(ExtWrd(2,TSL[i])))+abs(y-nt(ExtWrd(3,TSL[i]))));
  end;
end;
// This searching algorithm depends on both lists being presorted.  When
// this is the case all IDs can be found in one pass instead of requiring
// a separate pass for each ID.  This is the advantage of presorted lists.
// Note: to designate an empty line in the schematic field, the empty line
// ID should be tilde '~' if sorting up, else if sorting down, use zero '0'.
// This ensures that the empty lines are never reached during the search.



procedure Swap(P1,P2: point) var P3: point;
  begin
    ID1:= SF[P1.x,P1.y]; ID2:= SF[P2.x,P2.y];
    if (SD[ID1].xfree and SD[ID2].xfree)
      then begin if(SD[ID1].yfree and SD[ID2].yfree)
        then begin P3:= P2; P2:= P1; P1:= P3; end
        else if(P1.y=P2.y)
          then begin P3.x:= P2.x; P2.x:= P1.x; P1.x:= P3.x; end; end
      else if(SD[ID1].yfree and SD[ID2].yfree and(P1.x=P2.x))
        then begin P3.y:= P2.y; P2.y:= P1.y; P1.y:= P3.y; end;
  end;

procedure SortMemo(Memo: TMemo);
var
 SortList: TStringList;
begin
 {Create temporary string list}
 SortList := TStringList.Create;
 try
  {Put contents of memo into string list}
  SortList.Assign(Memo.Lines);
  {Sort the contents of the string list}
  SortList.Sort;
  {Place back in Memo}
  Memo.Lines.Assign(SortList);
 finally
  SortList.Free;
 end; {try..finally}
end;


